/**************************************************************************//**
 * @file     main.c
 * @version  V2.03
 * $Revision: 2 $
 * $Date: 13/06/28 10:14a $ 
 * @brief    M051 Series General Purpose I/O Driver Sample Code
 *
 * @note
 * Copyright (C) 2011 Nuvoton Technology Corp. All rights reserved.
 *
 ******************************************************************************/
#include <stdio.h>
#include "M051Series.h"
#include <ScanLED.h>
#include <ScanKey.h>
#include <DMX512.h>

#define IDnumber 0
#define PLLCON_SETTING      SYSCLK_PLLCON_50MHz_XTAL
#define PLL_CLOCK           50000000

uint8_t u8Mode;
uint8_t u8Power;
uint8_t u8Modeflag;
uint8_t u8Powerflag;
extern uint8_t u8DMX512flag;
extern uint8_t u8DMX512[DMX512_size];

void DoMode(void)
{
	while(1){
		if(u8Mode == 0)
		{
			u8Modeflag = 0;		
			drawMode(1);
			SYS_SysTickDelay(300000);
			SYS_SysTickDelay(300000);
			drawString("Logo");
			
			while(1)
			{
				drawLogo("Nuvoton 3D LED Cube with DMX512");
				if(u8Modeflag|u8Powerflag)
					break;
			}
		}
		else if(u8Mode == 1)
		{
			u8Modeflag = 0;			
			drawMode(2);
			SYS_SysTickDelay(300000);
			SYS_SysTickDelay(300000);	
			drawString("Auto");

			while(1)
			{
				if(u8Modeflag|u8Powerflag)
					break;			
				growCubeRachel();
				if(u8Modeflag|u8Powerflag)
					break;
				growCubeRachel();
				if(u8Modeflag|u8Powerflag)
					break;
				growCubeRachel();
				if(u8Modeflag|u8Powerflag)
					break;
				playCube(140);
				if(u8Modeflag|u8Powerflag)
					break;
				playHinges(240); // plays through once
				if(u8Modeflag|u8Powerflag)
					break;
				playHinges(160); // leads into ceiling for layers going down
				if(u8Modeflag|u8Powerflag)
					break;
				playLayer(220); // good - does each layer once
				if(u8Modeflag|u8Powerflag)
					break;
				playSine(280); //280 has good landing for rain
				if(u8Modeflag|u8Powerflag)
					break;
				playRain(50);
				if(u8Modeflag|u8Powerflag)
					break;
				growAndRotateSphere(3,3,4);
				if(u8Modeflag|u8Powerflag)
					break;
				randMoveSphere( 3,3,4, 13);
				if(u8Modeflag|u8Powerflag)
					break;
				playDancingMan();
				if(u8Modeflag|u8Powerflag)
					break;
				playSolidWave();
				if(u8Modeflag|u8Powerflag)
					break;
				playSolidWave();
				if(u8Modeflag|u8Powerflag)
					break;
				playSolidWave();
				if(u8Modeflag|u8Powerflag)
					break;
				playSolidWave();
				if(u8Modeflag|u8Powerflag)
					break;
				scrollMiamiM();
				if(u8Modeflag|u8Powerflag)
					break;
				scrollMiamiM();			

			}
		}
		else if(u8Mode == 2)
		{
			u8Modeflag = 0;				
			drawMode(3);
			SYS_SysTickDelay(300000);
			SYS_SysTickDelay(300000);	
			drawString("DMX512");

			while(1)
			{
				if(u8DMX512flag)
				{
					if(u8DMX512[0]==0x00)
					{//Control LED On/off
						LED_Updata(u8DMX512+IDnumber*64+1);
					}else//Control lightness
						LED_Lightness(u8DMX512[1]);
					u8DMX512flag = 0;
				}
				if(u8Modeflag|u8Powerflag)
					break;
			}
			LED_Lightness(0);
		}	
		if(u8Power == 0)
		{
			break;
		}
	}
}
/*---------------------------------------------------------------------------------------------------------*/
/* MAIN function                                                                                           */
/*---------------------------------------------------------------------------------------------------------*/
int main (void)
{
	uint8_t i = 0;
	_GPIO_SET_PIN_MODE(P4, 3, GPIO_PMD_OUTPUT);
	LED_Init();
	Key_Init();
	DMX512_Init();

	SYS_SysTickDelay(300000);
#if(IDnumber ==0)
	drawString("NO 0");
#else
	drawString("NO 1");
#endif	
	
	LEDisplay1();
	LED_TurnOnAll();
	SYS_SysTickDelay(300000);
	SYS_SysTickDelay(300000);	
	LED_TurnOffAll();
	while(1)
	{
	
		if(u8Power)
		{
			u8Powerflag = 0;	
			LED_Lightness(0);
			drawString("ON");
			DoMode();
			u8Powerflag = 0;			
			drawString("OFF");
		}
		//LEDisplay3();
		LEDisplay4();
		
		if(i>4)
		{
			LED_Lightness(8-i++);
		}else
		{
			LED_Lightness(i++);
		}
		if(i>8)
			i=0;
// 		DMX512_SendData((uint8_t*) 0);
// 		SYS_SysTickDelay(300000);	
		//printf("i love you");
	}
}
